﻿Imports System.IO.Ports
Imports System.Threading

Module Module1
    Dim sp As SerialPort

    Sub Main()
        Dim done As String = "N"
        'Initialize the serial port
        sp = New SerialPort()
        sp.PortName = "COM6"
        sp.BaudRate = 115200
        sp.ReadTimeout = 500
        sp.WriteTimeout = 500
        AddHandler sp.DataReceived, AddressOf DataReceivedHandler

        sp.Open()

        Console.Write("Press and key to continue or q to quit: ")
        While (True)
            done = Console.ReadLine()
            If (done = "q") Then
                Exit While
            End If
            SendPacket()
        End While

    End Sub

    'Packet for testing
    Sub SendPacket()
        Dim packetLen = 9
        Dim packet(packetLen) As Byte
        packet(0) = 255     'Start byte
        packet(1) = 255     'Start byte
        packet(2) = 7       'Length
        packet(3) = 10      'Command
        packet(4) = 1       'Payload 1..n
        packet(5) = 2
        packet(6) = 4
        packet(7) = 3
        packet(8) = 9       'Checksum = XOR(7,10,1,2,3,4)

        Console.WriteLine("Sent packet....{0}", BitConverter.ToString(packet))
        sp.Write(packet, 0, packetLen)
    End Sub

    Sub DataReceivedHandler(sender As Object, e As SerialDataReceivedEventArgs)
        Dim BytesToRead As Integer = sp.BytesToRead
        Dim BytesReceived As Integer = 0
        Dim buff(BytesToRead) As Byte

        'Write buffered bytes to the console
        While BytesToRead > 0
            BytesReceived = sp.Read(buff, 0, BytesToRead)
            Console.WriteLine("Echo...........{0}", BitConverter.ToString(buff))
            Console.WriteLine("Data Received..{0}{1}Bytes..........{2}{3}", BytesReceived, vbCrLf, BytesToRead, vbCrLf)
            BytesToRead -= BytesReceived
        End While
    End Sub


End Module



